function datatype = IsaacFindType(dataval)
% Retourne un datatype compatible avec dataval
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

if iscell(dataval)
	if iscellstr(dataval)
		if IsaacCheckType('LFIC',dataval)		
			datatype = 'LFIC';
		elseif IsaacCheckType('TABA',dataval)
			datatype = 'TABA';
		else
			datatype = 'TABX';
		end
	else
		datatype = 'TABX';
	end	
elseif isa(dataval,'char')
	if IsaacCheckType('NREP',dataval)		
		datatype = 'NREP';
	elseif IsaacCheckType('NFIC',dataval)
		datatype = 'NFIC';
	elseif IsaacCheckType('VALA',dataval)
		datatype = 'VALA';
	else
		datatype = 'VALX';
	end
elseif isa(dataval,'logical')	
	if IsaacCheckType('VALL',dataval)		
		datatype = 'VALL';
	elseif IsaacCheckType('TABL',dataval)
		datatype = 'TABL';
	else
		datatype = 'VALX';
	end
elseif isa(dataval,'numeric')	
	if IsaacCheckType('VALN',dataval)		
		datatype = 'VALN';
	elseif IsaacCheckType('TABN',dataval)
		datatype = 'TABN';
	else
		datatype = 'VALX';
	end
else	
	datatype = 'VALX';
end