function wp = IsaacWhitePoint(lightsource)
% Calcul du point blanc en coordonnes XYZ ou 0 si lightsource non gre
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

if isempty(lightsource)
	wp = 0; % erreur
else
	switch lightsource
		case '?'
			wp = [];
		case 'D50'
			wp = whitepoint('d50');
		case 'D55'
			wp = whitepoint('d55');
		case 'D65'
			wp = whitepoint('d65');
		case 'D75'
			wp = [];
		case 'A'
			wp = whitepoint('a');
		case 'C'
			wp = whitepoint('c');
		case 'E'
			wp = [];
		otherwise
			wp = 0; % erreur
	end	
end
