function obj = IsaacIMG_changedyn(obj,newmin,newmax)
% @IsaacIMG : ajustement dynamique vectoriel de l'image dans les limites du nb de bits
%              ROI et espace colorimtrique inchangs
%
% (Appeler en TRY-CATCH pour sortie en erreur d'execution)
%
% - newmin,newmax : valeurs min et max dans [0 1] relatif au nombre de bits
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

global ISAACPREF

if (obj.nbb == 1)
	error('ajustement de dynamique impossible')
end
if (~isscalar(newmin) || (newmin < 0) || (newmin > 1) || ...
	~isscalar(newmax) || (newmax < 0) || (newmax > 1))
	error('argument incorrect')
end
if (obj.bitclass < 32)
	maxclass = (2^obj.bitclass - 1);
else
	maxclass = 1;
end	
% nb : si newmin > newmax alors inversion vido
oldmin = min(obj.min); % min vectoriel pour nb plans >= 1
oldmax = max(obj.max); % max vectoriel pour nb plans >= 1
if (oldmin == oldmax)
	oldmin = 0;
	oldmax = obj.valmax;
end
for i = 1:obj.dimz
	obj.img(:,:,i) = imadjust(obj.img(:,:,i),[oldmin,oldmax]/maxclass, ...
		[newmin,newmax]*obj.valmax/maxclass);
end
if (obj.dimz == 1)
	obj.min = double(min(min(obj.img)));
	obj.max = double(max(max(obj.img)));
else
	obj.min = reshape(double(min(min(obj.img))),1,obj.dimz); % (matrice 1xdimz)
	obj.max = reshape(double(max(max(obj.img))),1,obj.dimz); % (matrice 1xdimz)
end
% recalcul masque de roi valeurs, le masque de roi spatiale reste inchang
if (obj.isroi && ~ISAACPREF.OptimiseImgMem)
	% si ~obj.isroi le masque valeur reste  false de dimension inchange
	obj.roivalmask = IsaacROI_valmask(obj.roi,obj.img);
end
