function obj = IsaacIMG_crop(obj,rect)
% @IsaacIMG : dcoupe l'image selon rect
%           ROI dcoupe idem, espace colorimtrique inchang
%
% (Appeler en TRY-CATCH pour sortie en erreur d'execution)
%
%	- rect : rectangle
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

global ISAACPREF

try
	obj.img = obj.img(rect(2):rect(2)+rect(4)-1,rect(1):rect(1)+rect(3)-1,:);
	obj.dimx = rect(3);
	obj.dimy = rect(4);
	% taille mini 2x2xdimz pour faciliter les calculs (1x1 => cas particuliers)
	if ((obj.dimx < 2) || (obj.dimy < 2))
		error('pour provoquer le catch')
	end
catch
	error('argument incorrect')
end
if (obj.dimz == 1)
	obj.min = double(min(min(obj.img)));
	obj.max = double(max(max(obj.img)));
else
	obj.min = reshape(double(min(min(obj.img))),1,obj.dimz); % (matrice 1xdimz)
	obj.max = reshape(double(max(max(obj.img))),1,obj.dimz); % (matrice 1xdimz)
end
% Ajustement de roi
obj.roi = IsaacROI_crop(obj.roi,rect);
% Recalcul des masques de roi
if ~ISAACPREF.OptimiseImgMem 
	obj.roispamask = IsaacROI_spamask(obj.roi);
	obj.roivalmask = IsaacROI_valmask(obj.roi,obj.img);
end