function obj = IsaacIMG_subplans(obj,plans)
% @IsaacIMG : supprime de l'image les plans dsigns par la matrice plans
%        La ROI est rorganise idem, l'espace colorimtrique est supprim
%
%	- plans  : matrice(1,n) des numros de plans  supprimer, 1 <= n < dimz
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

global ISAACPREF

if ((size(plans,1) ~= 1) || (size(plans,2) >= obj.dimz) || any(plans < 1) || ...
	any(plans > obj.dimz) || (length(unique(plans)) ~= length(plans))) % erreur si doublons
	error('argument incorrect')
end
% image
obj.img(:,:,plans) = [];
obj.min(plans) = [];
obj.max(plans) = [];
obj.dimz = size(obj.img,3);
% rorganisation ROI et recalcul masque valeur, masque spatial inchang
obj.roi = IsaacROI_subplans(obj.roi,plans);
if obj.isroi 
	if ~ISAACPREF.OptimiseImgMem
		% si ~obj.isroi le masque reste  false de dimension inchange
		obj.roivalmask = IsaacROI_valmask(obj.roi,obj.img);
	end
end
% Suppression espace colorimtrique
if obj.iscolorspace
	obj.colorspace = IsaacECOL(); % espace indtermin par dfaut
	obj.iscolorspace = false;
end
