function IsaacImage_finfo(obj)
% @IsaacImage : affiche des informations sur un fichier image
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

global ISAACCONST

if (obj.status == -1)
	IsaacMessageInfo(true,['image ',IsaacIMG_get(obj.img,'ImgName')],'Aucun fichier correspondant')
else
	[~,~,ext] = fileparts(obj.filename);
	if strcmp(ext,ISAACCONST.ExtImg)
		info = 'Fichier image au format propritaire Issac';
	else
		try
			info = imfinfo(obj.filename);
		catch
			info = 'Format de fichier inconnu';
		end	
	end
	if isstruct(info) && length(info) > 1 % image multicomposantes en tif
		IsaacMessageInfo(true,['image ',obj.filename,' (',num2str(length(info)),' plans)'],info(1))
	else	
		IsaacMessageInfo(true,['image ',obj.filename],info)
	end	
end	

