function obj = IsaacLPIX(varargin)
% @IsaacLPIX : constructeur
%
% (Appeler en TRY-CATCH pour sortie en erreur d'execution)
%
%	obj = IsaacLPIX()
%		=> objet @IsaacLPIX vide par dfaut
%
%	obj = IsaacLPIX(filename)
%		=> objet @IsaacLPIX lu dans un fichier
%
%	- filename	: nom du fichier dans rpertoire courant ou nom complet
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------
				
% IMAGE DE RFRENCE
%
%	ima_dimx	: coordonne x maximum = max(pix_mat(:,1))
%	ima_dimy	: coordonne y maximum = max(pix_mat(:,2))
%	ima_dimz	: nombre de plans = size(pix_mat,2) - 2
%
% PIXELS
%
%	nbpix		: nombre de lignes de pix_mat
%	pix_mat	: matrice(nbpix,ima_dimz + 2) de [x,y,v1,...,vz]
%				  avec 1 <= x <= ima_dimx, 1 <= y <= ima_dimy, 0 <= vp <= 1 et 1 <= p <= ima_dimz
%
%				  ATTENTION : pix_mat code en DOUBLE avec valeurs 64 bits dans [0 1]
%
%	version	: version de l'objet 

%---------------------------------------------------------------------------------------------------

objversion = 1;

%---------------------------------------------------------------------------------------------------

global ISAACPREF

switch nargin
	case 0
		% Objet initialis vide
		obj.ima_dimx = 0;
		obj.ima_dimy = 0;
		obj.ima_dimz = 0;
		obj.nbpix = 0;
		obj.pix_mat	= [];
		obj.version = objversion;
		obj = class(orderfields(obj),'IsaacLPIX'); % orderfields car class est sensible  l'ordre
	case 1
		% Lecture dans un fichier
		try
			warning off
			var = load('-mat',varargin{1},'LPIX'); % variable LPIX dans le fichier
			warning on
			obj = var.LPIX;
			if ~isa(obj,'IsaacLPIX')
				% erreur affiche par loadobj
				error('pour provoquer le catch')
			end
		catch
			error('fichier invalide')
		end
		if (obj.ima_dimz > ISAACPREF.ImMaxPlans)
			error('le nombre de plans dpasse la limite fixe en prfrences')
		end
	otherwise
		 error('nombre d''arguments incorrect')
end