function ok = IsaacLPIX_check(obj,propname,varargin)
% @IsaacLPIX : vrifie la compatibilit de obj avec les caractristiques d'une matrice image
%
% propname		varargin
% --------		--------
% 'PixSpa'		dimx,dimy
% 'PixVal'		dimz
% 'PixSpaVal'	dimx,dimy,dimz
%
%	- dimx,dimy,dimz : dimensions image
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

switch propname
	case 'PixSpa'
		% test spatial
		if (nargin == 4)
			ok = (varargin{1} >= obj.ima_dimx) && (varargin{2} >= obj.ima_dimy);
		else
			error('nombre d''arguments incorrect')
		end	
	case 'PixVal'
		% test du nb de plans
		if (nargin == 3)
			ok = (varargin{1} == obj.ima_dimz);
		else
			error('nombre d''arguments incorrect')
		end	
	case 'PixSpaVal'
		% test complet
		if (nargin == 5)
			ok = (varargin{1} >= obj.ima_dimx) && (varargin{2} >= obj.ima_dimy) && ...
				(varargin{3} == obj.ima_dimz);
		else
			error('nombre d''arguments incorrect')
		end	
	otherwise
		error('argument incorrect')
end

