function val = IsaacLPIX_get(obj,propname)
% @IsaacLPIX : lecture d'une proprit
%
% propname		val
% --------		---
% 'ImaRef'		structure = caractristiques de l'image de rfrence
% 'Pix'			obj.pix_mat
% 'PixNb'		obj.nbpix
% 'PixSpa'		obj.pix_mat(:,1:2) ou []
% 'PixVal'		obj.pix_mat(:,3:end) ou []
%
%	ATTENTION : val de 'Pix', 'PixSpa' et 'PixVal' codes en DOUBLE avec valeurs 64 bits dans [0 1]
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

switch propname
	case 'ImaRef'
		val.dimx	= obj.ima_dimx;
		val.dimy	= obj.ima_dimy;
		val.dimz	= obj.ima_dimz;
	case 'Pix'
		val = obj.pix_mat;
	case 'PixNb'
		val = obj.nbpix;
	case 'PixSpa'
		if (obj.nbpix > 0)
			val = obj.pix_mat(:,1:2);
		else
			val = [];
		end	
	case 'PixVal'
		if (obj.nbpix > 0)
			val = obj.pix_mat(:,3:end);
		else
			val = [];
		end	
	otherwise
		error('argument incorrect')
end