function obj = IsaacROI_clear(obj,varargin)
% @IsaacROI : supprime tous les intervalles spatiaux et/ou valeurs
%
%	obj = IsaacROI_clear(obj,propname1,...,propnameN)
%
% propname	
% --------
% 'RoiSpaVal'
% 'RoiSpa'
% 'RoiVal' 	
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

if (nargin < 2)
	error('nombre d''arguments incorrect')
end
propargin = varargin;
while ~isempty(propargin)
	propname = propargin{1};
	propargin = propargin(2:end);
	switch propname
		case 'RoiSpaVal'
			obj.spa_nb = 0;
			obj.spa_mat = [];
			obj.val_nb = 0;
			obj.val_mat = [];
		case 'RoiSpa'
			obj.spa_nb = 0;
			obj.spa_mat = [];
		case 'RoiVal'
			obj.val_nb = 0;
			obj.val_mat = [];
		otherwise
			error('argument incorrect')
	end
end