function obj = IsaacROI_rotate(obj,val)
% @IsaacROI : rotation de l'image de rfrence dans le sens inverse des aiguilles d'une montre
%				  en ajustant la roi spatiale
%
%	- val : angle de rotation = 90/180/270 
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

if ~ismember(val,[90,180,270])
	error('argument incorrect')
end
spamat = obj.spa_mat;
switch val
	case 90
		dimx = obj.ima_dimy;
		dimy = obj.ima_dimx;
		if obj.spa_nb
			spamat(:,1) = obj.spa_mat(:,3);
			spamat(:,2) = obj.spa_mat(:,4);
			spamat(:,3) = dimy - obj.spa_mat(:,2) + 1;
			spamat(:,4) = dimy - obj.spa_mat(:,1) + 1;
		end	
	case 180
		dimx = obj.ima_dimx;
		dimy = obj.ima_dimy;
		if obj.spa_nb
			spamat(:,1) = dimx - obj.spa_mat(:,2) + 1;
			spamat(:,2) = dimx - obj.spa_mat(:,1) + 1;
			spamat(:,3) = dimy - obj.spa_mat(:,4) + 1;
			spamat(:,4) = dimy - obj.spa_mat(:,3) + 1;
		end	
	case 270
		dimx = obj.ima_dimy;
		dimy = obj.ima_dimx;
		if obj.spa_nb
			spamat(:,1) = dimx - obj.spa_mat(:,4) + 1;
			spamat(:,2) = dimx - obj.spa_mat(:,3) + 1;
			spamat(:,3) = obj.spa_mat(:,1);
			spamat(:,4) = obj.spa_mat(:,2);
		end	
end
obj.spa_mat = spamat;
obj.ima_dimx = dimx;
obj.ima_dimy = dimy;