function IsaacCD(dirname)
% Appel virtuel  cd(dirname) avec positionnement en ISAACPRIV.LastDir en cas d'erreur
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

global ISAACPRIV
global ISAACPREF
global ISAACCONST

savedir = pwd;
try
	cd(dirname)
	ISAACPRIV.LastDir = dirname;
catch
	try
		cd(ISAACPRIV.LastDir)
	catch
		try
			cd(ISAACPREF.DefaultDir)
			ISAACPRIV.LastDir = ISAACPREF.DefaultDir;
		catch
			IsaacMessageWarning(['Rpertoire ',ISAACPREF.DefaultDir,' inaccessible'], ...
			'Valeur rinitialise')   
			ISAACPREF.DefaultDir = fileparts(ISAACCONST.IsaacDir);
			cd(ISAACPREF.DefaultDir)
			ISAACPRIV.LastDir = ISAACPREF.DefaultDir;
		end	
	end	
end	
cd(savedir)