function pos = IsaacFenPos(leftpos, downpos, width, height, ismenubar)
% Calcule la proprit position d'une fentre  partir de celle du coin exterieur sup-gauche / 
% ISAACCONST.Screen.refpos et des dimensions internes voulues.
%
% Retourne pos en coordonnees Matlab. L'emplacement voulu de la fentre est si necessaire modifi 
% afin de garantir un bon positionnement dans l'cran
%
% RAPPEL : Dans Matlab, la position des fentres ne tient pas compte des bords et c'est le coin 
% inf-gauche de screensize qui a les coordonnees 0-0
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

global ISAACCONST

% dcalage  gauche si ncessaire
delta = leftpos + ISAACCONST.EpFen(3) + width + ISAACCONST.EpFen(4) - ...
	ISAACCONST.Screen.limits(2);
if delta > 0
	leftpos = leftpos - delta;
end
% alignement  gauche si ncessaire (avec ventuellement dpassement  droite)
if leftpos < ISAACCONST.Screen.limits(1)
	leftpos = ISAACCONST.Screen.limits(1);
end	
% left position
pos(1) = ISAACCONST.Screen.refpos(1) + leftpos + ISAACCONST.EpFen(3);

% dcalage vers le haut si ncessaire
delta = downpos + ISAACCONST.EpFen(1) + ismenubar*ISAACCONST.EpFenMenuBar + height + ...
	ISAACCONST.EpFen(2)  - ISAACCONST.Screen.limits(4);
if delta > 0
	downpos = downpos - delta;
end
% alignement en haut si ncessaire (avec ventuellement dpassement en bas)
if downpos < ISAACCONST.Screen.limits(3)
	downpos = ISAACCONST.Screen.limits(3);	 
end

% bottom position
pos(2) = ISAACCONST.Screen.refpos(2) - downpos - ISAACCONST.EpFen(1) - ...
	ismenubar*ISAACCONST.EpFenMenuBar - height;

% width position
pos(3) = width;
% height position
pos(4) = height;
