function param = IsaacParamPull(paramtype)
% Lit un paramtre en mmoire
% Retourne [] si aucun paramtre sauvegard
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

global ISAACPRIV

if ~IsaacParamCheck(paramtype)
	param = [];
	return
end	
switch paramtype
	case 'DATA'
		% espace colorimrique (objet @IsaacDATA)
		param = ISAACPRIV.ParamMem.DATA;
	case 'ECOL'
		% espace colorimrique (objet @IsaacECOL)
		param = ISAACPRIV.ParamMem.ECOL;
	case 'HISTO'
		% histogramme (objet @IsaacHISTO)
		param = ISAACPRIV.ParamMem.HISTO;
	case 'IMG'
		% image (objet @IsaacIMG)
		param = ISAACPRIV.ParamMem.IMG;
	case 'LPIX'
		% liste de pixels (objet @IsaacLPIX)
		param = ISAACPRIV.ParamMem.LPIX;
	case 'ROI'
		% rgion d'intrt (objet @IsaacROI)
		param = ISAACPRIV.ParamMem.ROI;
end
