function varargout = ImConcat(varargin)
% Concatne image2 avec image1 en suivant les caractristiques de image1
% les ROI sont concatnes, les espaces colorimtriques sont supprims
%
% INPUT:
% - image1 P1xQ1
% - image2 P2xQ2
%
% OUTPUT:
% - image (P1+P2)xQ1
%
% Plugin for OpenIsaac
% version 1
%  2011-2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

% PLUGIN PARAMETERS
if (nargin == 1) && strcmp(varargin{1},'-f')
    % input
	varargout{1} = {'IMG','image1', ...
					'IMG','image2'};
    % output
	varargout{2} = {'IMG','image'};
	return
end	

% INPUT
ObjIMG1 = varargin{1};
ObjIMG2 = varargin{2};

%---------------------------------------------------------------------------------------------------

ObjIMG1 = IsaacIMG_concat(ObjIMG1,ObjIMG2);

%---------------------------------------------------------------------------------------------------

% OUTPUT
varargout{1} = ObjIMG1;