function DataEdit_cb(choix)
% Callback DataEdit
%
% Tool for OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

% N'utilise pas la rception d'vnements causs par (auteur = soi-mme) pour mise  jour graphique

%---------------------------------------------------------------------------------------------------

global ISAACINFO

switch(choix)

% DATA ---------------------------------------------------------------------------------------------

case 'PopupType'
	ud = get(gcbf,'UserData');
	set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
	val = get(gcbo,'Value');
	s = get(gcbo,'String');
	try
		ud.Param = IsaacDATA_set(ud.Param,'Type',s{val});
	catch
		set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
			'String',['type ',s{val},' incompatible'])
		% rinitialisation du menu
		DataEdit_maj(gcbf,'Popup','Valeurs');
		return
	end
	set(gcbf,'UserData',ud);
	DataEdit_maj(gcbf,'Valeurs');
case 'ButLVaddfic'
	set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
	[filename,dirname] = IsaacUIgetfile('Choisir un fichier :');
	if filename ~= 0
		ud = get(gcbf,'UserData');
		ud.Param = IsaacDATA('NFIC',fullfile(dirname,filename),IsaacDATA_get(ud.Param,'Info'));
		set(gcbf,'UserData',ud);
		DataEdit_maj(gcbf,'Popup','Valeurs');
	end
case 'ButLVaddficliste'
	set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
	dirname = IsaacUIgetdir('Choisir un dossier :');
	if dirname ~= 0
		ud = get(gcbf,'UserData');
		liste = IsaacDir(dirname,'f',true,get(findobj(gcbf,'Tag','ChkRecursif'),'Value'));
		ud.Param = IsaacDATA('LFIC',liste,IsaacDATA_get(ud.Param,'Info'));
		set(gcbf,'UserData',ud);
		DataEdit_maj(gcbf,'Popup','Valeurs');
	end
case 'ButLVaddrep'
	set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
	dirname = IsaacUIgetdir('Choisir un dossier :');
	if dirname ~= 0
		ud = get(gcbf,'UserData');
		ud.Param = IsaacDATA('NREP',dirname,IsaacDATA_get(ud.Param,'Info'));
		set(gcbf,'UserData',ud);
		DataEdit_maj(gcbf,'Popup','Valeurs');
	end
case 'EtxtInfoVal'
	set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
	ud = get(gcbf,'UserData');
	s = get(gcbo,'String');
	try
		ud.Param = IsaacDATA_set(ud.Param,'Info',s);
   catch exception
		IsaacMessageErreur(IsaacError(exception))
	end
	set(gcbf,'UserData',ud);
		
% Gnral ------------------------------------------------------------------------------------------

case 'CloseBox'
	ud = get(gcbf,'UserData');
	rmpath(ud.ToolDir)
	closereq
case 'RadButParamWS'
	v = get(gcbo,'Value');
	if v == 1 % tait  0 vient d'tre mis  1
		ud = get(gcbf,'UserData');
		ud.PTarget = 1;
		set(gcbf,'UserData',ud);
		set(findobj(gcbf,'Tag','RadButParamMem'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamFich'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMATLAB'),'Value',0)
		set(findobj(gcbf,'Tag','ButParamPull'),'String','Importer var')
		set(findobj(gcbf,'Tag','ButParamPush'),'String','Exporter var')
		set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
		set(findobj(gcbf,'Tag','EtxtWSVarname'),'Visible','on')
		set(findobj(gcbf,'Tag','EtxtVarname'),'Visible','off')
	else % tait  1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'RadButParamMem'
	v = get(gcbo,'Value');
	if v == 1 % tait 0 vient d'tre mis  1
		ud = get(gcbf,'UserData');
		ud.PTarget = 2;
		set(gcbf,'UserData',ud);
		set(findobj(gcbf,'Tag','RadButParamWS'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamFich'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMATLAB'),'Value',0)
		set(findobj(gcbf,'Tag','ButParamPull'),'String','Lire')
		set(findobj(gcbf,'Tag','ButParamPush'),'String','Ecrire')
		set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
		set(findobj(gcbf,'Tag','EtxtWSVarname'),'Visible','off')
		set(findobj(gcbf,'Tag','EtxtVarname'),'Visible','off')
		set(gcbf,'UserData',ud);
	else % tait  1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'RadButParamFich'
	v = get(gcbo,'Value');
	if v == 1 % tait 0 vient d'tre mis  1
		ud = get(gcbf,'UserData');
		ud.PTarget = 3;
		set(gcbf,'UserData',ud);
		set(findobj(gcbf,'Tag','RadButParamWS'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMem'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMATLAB'),'Value',0)
		set(findobj(gcbf,'Tag','ButParamPull'),'String','Ouvrir...')
		set(findobj(gcbf,'Tag','ButParamPush'),'String','Sauver sous...')
		set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
		set(findobj(gcbf,'Tag','EtxtWSVarname'),'Visible','off')
		set(findobj(gcbf,'Tag','EtxtVarname'),'Visible','off')
	else % tait  1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end
case 'RadButParamMATLAB'
	v = get(gcbo,'Value');
	if v == 1 % tait 0 vient d'tre mis  1
		ud = get(gcbf,'UserData');
		ud.PTarget = 4;
		set(gcbf,'UserData',ud)
		set(findobj(gcbf,'Tag','RadButParamWS'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMem'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamFich'),'Value',0)
		set(findobj(gcbf,'Tag','ButParamPull'),'String','Importer')
		set(findobj(gcbf,'Tag','ButParamPush'),'String','Exporter')
		set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
		set(findobj(gcbf,'Tag','EtxtWSVarname'),'Visible','off')
		set(findobj(gcbf,'Tag','EtxtVarname'),'Visible','on')
	else % tait  1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end
case 'EtxtWSVarname'
	ud = get(gcbf,'UserData');
	ud.WSVarName = get(gcbo,'String');
	set(gcbf,'UserData',ud);
	set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
case 'EtxtVarname'
	ud = get(gcbf,'UserData');
	ud.PVarName = get(gcbo,'String');
	set(gcbf,'UserData',ud);
	set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
case 'ButParamPull'
	ud = get(gcbf,'UserData');
	switch ud.PTarget
		case 1 % Base Workspace
			try
				ud.Param = IsaacDATA_import(ud.Param,ud.WSVarName);
				set(gcbf,'UserData',ud);
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
					'String',['variable ',ud.WSVarName,' importe'])
				DataEdit_maj(gcbf,'Popup','Valeurs');
         catch exception
				IsaacMessageErreur(IsaacError(exception))
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
					'String','chec import variable')
				return
			end
		case 2 % Mmoire
			P = IsaacParamPull('DATA');
			if isempty(P)
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
					'String','mmoire vide')
			else
				ud.Param = P;
				set(gcbf,'UserData',ud);
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
					'String','mmoire lue')
				DataEdit_maj(gcbf,'Popup','Valeurs');
			end	
		case 3 % Fichier
			[filename,dirname] = IsaacUIgetfile('Ouvrir une donne :');
			if filename == 0
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
				return
			end
			try
				ud.Param = IsaacDATA(fullfile(dirname,filename));
				IsaacCD(dirname)
				set(gcbf,'UserData',ud);	
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
					'String',['fichier ',filename,' lu'])
				DataEdit_maj(gcbf,'Popup','Valeurs');
         catch exception
				IsaacMessageErreur(IsaacError(exception))
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
					'String','chec lecture fichier')
				return
			end
		case 4 % MATLAB
			try
				ud.Param = IsaacParamImport('DATA',ud.PVarName);
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
					'String',['variable ',ud.PVarName,' importe'])
				set(gcbf,'UserData',ud);
				DataEdit_maj(gcbf,'Popup','Valeurs');
			catch exception
				IsaacMessageErreur(IsaacError(exception))
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
					'String','chec import MATLAB')
				return
			end	
	end
case 'ButParamPush'
	ud = get(gcbf,'UserData');
	switch ud.PTarget
		case 1 % Base Workspace
			try
 				IsaacDATA_export(ud.Param,ud.WSVarName)
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
					'String',['variable ',ud.WSVarName,' exporte'])
         catch exception
				IsaacMessageErreur(IsaacError(exception))
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
					'String','chec export variable')
				return
			end
		case 2 % Mmoire
			IsaacParamPush(ud.Param)
			set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
				'String','DATA mmoris')
		case 3 % Fichier
			[filename,dirname] = IsaacUIputfile('Sauver sous :',IsaacFileName('DATA.mat'));
			if filename == 0
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
				return
			end
			try
				IsaacDATA_saveas(ud.Param,fullfile(dirname,filename));
				IsaacCD(dirname)
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
					'String',['fichier ',filename,' sauv'])
			catch exception
				IsaacMessageErreur(IsaacError(exception))
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
					'String','chec criture fichier')
				return
			end
		case 4 % MATLAB
			try
				IsaacParamExport(ud.Param,ud.PVarName)
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
					'String',['variable ',ud.PVarName,' exporte'])
			catch exception
				IsaacMessageErreur(IsaacError(exception))
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
					'String','chec export MATLAB')
				return
			end				
	end
end
