function HistoEdit_upd(fighnd,event,eventobj,auteur)
% Reaction HistoEdit aux vnements recus
%
% @<- EVENEMENTS 1/2/31/41/51/61/71/111
%
% Tool for OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

% N'accepte pas les vnements causs par (auteur = soi-mme) pour mise  jour graphique

%---------------------------------------------------------------------------------------------------

if (auteur == fighnd) 
	return
end	

global ISAACINFO

switch event
case 1 
	% pas d'image cible
	ud = get(fighnd,'UserData');
	if (ud.PTarget ~= 1)
		return
	end
	ud.Param = [];
	set(fighnd,'UserData',ud)
	set(findobj(fighnd,'Tag','StxtParamInfo'),'String','')
	% popup string = 1 espace (et pas '') sinon le popup ne s'affiche pas
	set(findobj(fighnd,'Tag','PopupDim'),'Enable','off','String',' ','Value',1)
	set(findobj(fighnd,'Tag','PopupPlan1'),'Enable','off','String',' ','Value',1)
	set(findobj(fighnd,'Tag','PopupPlan2'),'Enable','off','String',' ','Value',1)
	set(findobj(fighnd,'Tag','PopupPlan3'),'Enable','off','String',' ','Value',1)
	set(findobj(fighnd,'Tag','RadShowGraph'),'Enable','off','Value',0)
	set(findobj(fighnd,'Tag','RadShowInfos'),'Enable','off','Value',0)
	set(findobj(fighnd,'Tag','StxtEffMin'),'String','')
	set(findobj(fighnd,'Tag','StxtEffMax'),'String','')
	set(findobj(fighnd,'Tag','StxtEffTotal'),'String','')
	set(findobj(fighnd,'Tag','EtxtEffVisMin'),'Enable','off','String','')
	set(findobj(fighnd,'Tag','EtxtEffVisMax'),'Enable','off','String','')
	set(findobj(fighnd,'Tag','RadRoiNon'),'Enable','off','Value',0)
	set(findobj(fighnd,'Tag','RadRoiOui'),'Enable','off','Value',0)
	set(findobj(fighnd,'Tag','RadRoiVoir'),'Enable','off','Value',0)
	set(findobj(fighnd,'Tag','ChkRoiMark'),'Enable','off','Value',0)
	set(findobj(fighnd,'Tag','ButUnion'),'Enable','off')
	set(findobj(fighnd,'Tag','ButIntersect'),'Enable','off')
	set(findobj(fighnd,'Tag','ButDiffer'),'Enable','off')
	set(findobj(fighnd,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
		'String','pas d''image cible')
	axes(ud.AxHisto) % ud.AxHisto = current
	cla reset % delete all et reset current axes sauf Units et Position
	set(ud.AxHisto,'Visible','off')
	set(ud.AxColorbar,'Visible','off')
	set(get(ud.AxColorbar,'Children'),'Visible','off')
	set(findobj(fighnd,'Tag','ListHistoInfo'),'String','','Visible','off')
	set(findobj(fighnd,'Tag','ButHistG'),'Enable','off')
	set(findobj(fighnd,'Tag','ButHistB'),'Enable','off')
	set(findobj(fighnd,'Tag','ButHistC'),'Enable','off')
	set(findobj(fighnd,'Tag','ButHistH'),'Enable','off','Value',0)
	set(findobj(fighnd,'Tag','ButHistD'),'Enable','off')
	set(findobj(fighnd,'Tag','ChkBigDot'),'Enable','off','Value',0)
	set(findobj(fighnd,'Tag','ButScreenCopy'),'Enable','off')
case {2,31} 
	% changement cible ou rinitialisation ou modif nb plans/nb bits
	ud = get(fighnd,'UserData');
	if (ud.PTarget ~= 1)
		return
	end	
	paramr = IsaacImage_get(eventobj,'ParamR');
	ud.NbPlans = paramr.dimz;
	ud.PlansStr = cellstr(num2str((1:ud.NbPlans)'));
	if (ud.AffDim > ud.NbPlans)
		ud.AffDim = ud.NbPlans;
		ud.AffPlans = ud.AffPlans(1:ud.AffDim);
	end
	ud.AffPlans = min(ud.AffPlans,ud.NbPlans);
	if (length(unique(ud.AffPlans)) ~= length(ud.AffPlans)) % il y a des doublons
		ud.AffPlans = 1:ud.AffDim;
	end
	ud = HistoEdit_maj(fighnd,ud,'Plans','Vue3D');
	set(findobj(fighnd,'Tag','PopupDim'),'Enable','on','String',ud.PlansStr,'Value',ud.AffDim)
	if (event == 2)
		set(findobj(fighnd,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
			'String',IsaacImage_get(eventobj,'Name'))
		set(findobj(fighnd,'Tag','RadShowInfos'),'Enable','on')
		set(findobj(fighnd,'Tag','ButScreenCopy'),'Enable','on')
	end
	UpdateRoi
	ud.Param = IsaacHISTO(IsaacImage_get(eventobj,'IMG'),(ud.AffRoi == 1),ud.AffPlans);
	if (ud.AffRoi == 2)
		ud.HistoROI = IsaacHISTO(IsaacImage_get(eventobj,'IMG'),true,ud.AffPlans);
	else
		ud.HistoROI = [];
	end
	countsref = IsaacHISTO_get(ud.Param,'CountsRef');
	ud.VisMax = countsref.effmax;
	if (event == 2)
		ud.VisMin = 0;
	else	
		if (ud.VisMin >= ud.VisMax)
			ud.VisMin = 0;
		end
	end
	ud = HistoEdit_maj(fighnd,ud,'Nom','Effectifs','Labels'); % aprs mise  jour histo et counts
	if ud.ShowGraph
		set(findobj(fighnd,'Tag','ListHistoInfo'),'Visible','off')
		set(ud.AxHisto,'Visible','on')
		set(findobj(fighnd,'Tag','ChkBigDot'),'Enable','on','Value',ud.BigDot)
	else
		set(ud.AxHisto,'Visible','off')
		set(findobj(fighnd,'Tag','ListHistoInfo'),'Visible','on')
		set(findobj(fighnd,'Tag','ChkBigDot'),'Enable','off','Value',0)
	end	
	ShowHisto(ud)
	set(fighnd,'UserData',ud)
case {41,51,61} % modif image
	ud = get(fighnd,'UserData');
	if (ud.PTarget ~= 1)
		return
	end
	UpdateRoi
	ud.Param = IsaacHISTO(IsaacImage_get(eventobj,'IMG'),(ud.AffRoi == 1),ud.AffPlans);
	if (ud.AffRoi == 2)
		ud.HistoROI = IsaacHISTO(IsaacImage_get(eventobj,'IMG'),true,ud.AffPlans);
	else
		ud.HistoROI = [];
	end	
	countsref = IsaacHISTO_get(ud.Param,'CountsRef');
	ud.VisMax = countsref.effmax;
	if (ud.VisMin >= ud.VisMax)
		ud.VisMin = 0;
	end
	ud = HistoEdit_maj(fighnd,ud,'Nom','Effectifs'); % aprs mise  jour histo et counts
	ShowHisto(ud)
	set(fighnd,'UserData',ud);
case 71 % modif ROI seulement
	ud = get(fighnd,'UserData');
	if (ud.PTarget ~= 1)
		return
	end
	UpdateRoi
	if (ud.AffRoi == 1)
		ud.Param = IsaacHISTO(IsaacImage_get(eventobj,'IMG'),true,ud.AffPlans);
		ud.HistoROI = [];
		countsref = IsaacHISTO_get(ud.Param,'CountsRef');
		ud.VisMax = min(ud.VisMax,countsref.effmax);
		if (ud.VisMin >= ud.VisMax)
			ud.VisMin = 0;
		end
		ud = HistoEdit_maj(fighnd,ud,'Nom','Effectifs');
		ShowHisto(ud)
	elseif (ud.AffRoi == 2)
		ud.HistoROI = IsaacHISTO(IsaacImage_get(eventobj,'IMG'),true,ud.AffPlans);
		ShowHisto(ud)
	else
		ud.HistoROI = [];
	end
	set(fighnd,'UserData',ud);
case 111 
	% changement de nom image cible
	ud = get(fighnd,'UserData');
	if (ud.PTarget == 1)
		set(findobj(fighnd,'Tag','StxtTargetInfo'),'String',IsaacImage_get(eventobj,'Name'))
	end	
end

% --- Nested fonction ------------------------------------------------------------------------------

function UpdateRoi
	
if (IsaacImage_get(eventobj,'RSVEff') > 0)
	ud.IsRoi = true;
	if (ud.ShowGraph)
		if (ud.AffRoi == 2) 
			set(findobj(fighnd,'Tag','RadRoiVoir'),'Enable','on','Value',1)
			set(findobj(fighnd,'Tag','ChkRoiMark'),'Enable','on','Value',ud.IsRoiMark)
		else
			set(findobj(fighnd,'Tag','RadRoiVoir'),'Enable','on','Value',0)
			set(findobj(fighnd,'Tag','ChkRoiMark'),'Enable','off','Value',0)
		end
	else
		if (ud.AffRoi == 2)
			ud.AffRoi = 1;
		end
		set(findobj(fighnd,'Tag','RadRoiVoir'),'Enable','off','Value',0)
		set(findobj(fighnd,'Tag','ChkRoiMark'),'Enable','off','Value',0)
	end	
	set(findobj(fighnd,'Tag','RadRoiNon'),'Enable','on','Value',(ud.AffRoi == 0))
	set(findobj(fighnd,'Tag','RadRoiOui'),'Enable','on','Value',(ud.AffRoi == 1))
else
	ud.IsRoi = false;
	ud.AffRoi = 0;
	set(findobj(fighnd,'Tag','RadRoiNon'),'Enable','on','Value',1)
	set(findobj(fighnd,'Tag','RadRoiOui'),'Enable','off','Value',0)
	set(findobj(fighnd,'Tag','RadRoiVoir'),'Enable','off','Value',0)
	set(findobj(fighnd,'Tag','ChkRoiMark'),'Enable','off','Value',0)
end

end % fin nested fonction

%---------------------------------------------------------------------------------------------------

end % fin HistoEdit_upd en raison des nested fonctions
