function ImageVal_cb(choix)
% Callback ImageVal
%
% Tool for OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

% N'utilise pas la rception d'vnements causs par (auteur = soi-mme) pour mise  jour graphique

%---------------------------------------------------------------------------------------------------

global ISAACINFO

switch(choix)
case 'CloseBox'
	ud = get(gcbf,'UserData');
	if ~ISAACINFO.IsEnd
		IsaacEventUpdListe(gcbf,[])
	end
	rmpath(ud.ToolDir)
	closereq
case 'ButEchantillon'
	cible = IsaacImageCible;
	rect = IsaacImage_mouserect(cible);
	if isempty(rect)
		return
	end
	objIMG = IsaacImage_get(cible,'IMG');
	try
		objIMG = IsaacIMG_crop(objIMG,rect);
		objIMG = IsaacIMG_set(objIMG,'ImgName',[IsaacIMG_get(objIMG,'ImgName'),'-e']);
		IsaacImage(gcbf,objIMG);
	catch exception
		IsaacMessageErreur(IsaacError(exception))
	end
case 'ButCreerPlans'
	plans = get(findobj(gcbf,'Tag','ListPlans'),'Value'); % slection multiple possible
	if isempty(plans)
		return
	end
	cible = IsaacImageCible;
	objIMG = IsaacImage_get(cible,'IMG');
	reste = setdiff(1:IsaacIMG_get(objIMG,'DimZ'),plans);
	if ~isempty(reste)
		objIMG = IsaacIMG_subplans(objIMG,reste);
		s = [IsaacIMG_get(objIMG,'ImgName'),'-',strrep(num2str(plans),' ','')];
		% strrep = suppression des espaces
		objIMG = IsaacIMG_set(objIMG,'ImgName',s);
	end	
	try
		IsaacImage(gcbf,objIMG);
	catch exception
		IsaacMessageErreur(IsaacError(exception))
	end
end	
