function LpixEdit_cb(choix)
% Callback LpixEdit
%
% Tool for OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

% N'utilise pas la rception d'vnements causs par (auteur = soi-mme) pour mise  jour graphique

%---------------------------------------------------------------------------------------------------

global ISAACINFO

switch(choix)

% LPIX ---------------------------------------------------------------------------------------------
case 'Rad1'
	v = get(gcbo,'Value');
	if v == 1 % tait  0 et vient d'tre mis  1
		ud = get(gcbf,'UserData');
		ud.BitFormat = 1;
		ud.PixValFormat = '%2.1i';
		set(findobj(gcbf,'Tag','Rad8'),'Value',0)
		set(findobj(gcbf,'Tag','Rad16'),'Value',0)
		set(findobj(gcbf,'Tag','Rad64'),'Value',0)
		if IsaacLPIX_get(ud.Param,'PixNb')
			MajListePix
		end	
		set(gcbf,'UserData',ud)
	else % tait  1 et vient d'tre mis  0
		set(gcbo,'Value',1)	
	end		
case 'Rad8'
	v = get(gcbo,'Value');
	if v == 1 % tait  0 et vient d'tre mis  1
		ud = get(gcbf,'UserData');
		ud.BitFormat = 8;
		ud.PixValFormat = '%4.3i';
		set(findobj(gcbf,'Tag','Rad1'),'Value',0)
		set(findobj(gcbf,'Tag','Rad16'),'Value',0)
		set(findobj(gcbf,'Tag','Rad64'),'Value',0)
		if IsaacLPIX_get(ud.Param,'PixNb')
			MajListePix
		end	
		set(gcbf,'UserData',ud)
	else % tait  1 et vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'Rad16'
	v = get(gcbo,'Value');
	if v == 1 % tait  0 et vient d'tre mis  1
		ud = get(gcbf,'UserData');
		ud.BitFormat = 16;
		ud.PixValFormat = '%6.5i';
		set(findobj(gcbf,'Tag','Rad1'),'Value',0)
		set(findobj(gcbf,'Tag','Rad8'),'Value',0)
		set(findobj(gcbf,'Tag','Rad64'),'Value',0)
		if IsaacLPIX_get(ud.Param,'PixNb')
			MajListePix
		end	
		set(gcbf,'UserData',ud)
	else % tait  1 et vient d'tre mis  0
		set(gcbo,'Value',1)	
	end
case 'Rad64'
	v = get(gcbo,'Value');
	if v == 1 % tait  0 et vient d'tre mis  1
		ud = get(gcbf,'UserData');
		ud.BitFormat = 64;
		ud.PixValFormat = '%7.4f';
		set(findobj(gcbf,'Tag','Rad1'),'Value',0)
		set(findobj(gcbf,'Tag','Rad8'),'Value',0)
		set(findobj(gcbf,'Tag','Rad16'),'Value',0)
		if IsaacLPIX_get(ud.Param,'PixNb')
			MajListePix
		end	
		set(gcbf,'UserData',ud)
	else % tait  1 et vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'ListLP'
	ud = get(gcbf,'UserData');
	pixspa = IsaacLPIX_get(ud.Param,'PixSpa');
	ud.PixL = get(gcbo,'Value');
	ud.PixE = pixspa(ud.PixL,:);
	set(gcbf,'UserData',ud);
	MajCoord
case 'EtxtCoord'
	ud = get(gcbf,'UserData');
	vstr = get(gcbo,'String');
	v = round(str2num(vstr));                                                                    %#ok
	% pas str2double car matrice 1x2 attendue  partir de vstr
   cible = IsaacImageCible;
	paramr = IsaacImage_get(cible,'ParamR');
	if(~isequal(size(v),[1 2]) || (v(1) < 1) || (v(1) > paramr.dimx) || ...
			(v(2) < 1) || (v(2) > paramr.dimy))
		% (ordre des termes du if important au cas ou v de dim>1)
		IsaacSound('Buzz')
		MajCoord
	else
		ud.PixE = v;
		MajCoord
		ud.Param = IsaacLPIX_change(ud.Param,[ud.PixL,ud.PixE],IsaacImage_get(cible,'IMG'));
		set(gcbf,'UserData',ud);
		MajListePix
	end	
case 'ButLPselect'
	val = IsaacImage_mousepix(IsaacImageCible);
	if isempty(val)
		IsaacMessageWarning('slection vide')
		return
	end
	ud = get(gcbf,'UserData');
	cible = IsaacImageCible;
	ud.Param = IsaacLPIX_add(ud.Param,val,IsaacImage_get(cible,'IMG'));
	ud.PixL = IsaacLPIX_get(ud.Param,'PixNb');
	pixspa = IsaacLPIX_get(ud.Param,'PixSpa');
	ud.PixE = pixspa(ud.PixL,:);
	set(gcbf,'UserData',ud);
	set(findobj(gcbf,'Tag','StxtLPeffval'),'String',num2str(ud.PixL))
	set(findobj(gcbf,'Tag','ListLP'),'Enable','on')
	MajListePix
	set(findobj(gcbf,'Tag','EtxtCoord'),'Enable','on')
	MajCoord
	set(findobj(gcbf,'Tag','ButLPadjust'),'Enable','on')
	set(findobj(gcbf,'Tag','ButLP-'),'Enable','on')
	set(findobj(gcbf,'Tag','ButLPclear'),'Enable','on')
case 'ButLPadjust'
	ud = get(gcbf,'UserData');
	cible = IsaacImageCible;
	ud.Param = IsaacLPIX_adjust(ud.Param,IsaacImage_get(cible,'IMG'));
	nbpix = IsaacLPIX_get(ud.Param,'PixNb');
	if nbpix
		pixspa = IsaacLPIX_get(ud.Param,'PixSpa');
		ud.PixL = nbpix;
		ud.PixE = pixspa(ud.PixL,:);
		set(findobj(gcbf,'Tag','StxtLPeffval'),'String',num2str(nbpix))
		MajListePix
		MajCoord
	else
		set(gcbo,'Enable','off')
		set(findobj(gcbf,'Tag','StxtLPeffval'),'String','0')
		set(findobj(gcbf,'Tag','ListLP'),'Enable','off','String','')
		set(findobj(gcbf,'Tag','EtxtCoord'),'Enable','inactive','String','')
		set(findobj(gcbf,'Tag','ButLPclear'),'Enable','off')
		set(findobj(gcbf,'Tag','ButLP-'),'Enable','off')
		set(findobj(gcbf,'Tag','StxtParamInfo'),'String','LPIX vide')
	end
	set(gcbf,'UserData',ud);
case 'ButLPclear'
	ud = get(gcbf,'UserData');
	ud.Param = IsaacLPIX_clear(ud.Param);
	set(gcbf,'UserData',ud);
	set(findobj(gcbf,'Tag','StxtLPeffval'),'String','0')
	set(findobj(gcbf,'Tag','ListLP'),'Enable','off','String','')
	set(findobj(gcbf,'Tag','EtxtCoord'),'Enable','inactive','String','')
	set(findobj(gcbf,'Tag','ButLPadjust'),'Enable','off')
	set(findobj(gcbf,'Tag','ButLP-'),'Enable','off')
	set(gcbo,'Enable','off')
	set(findobj(gcbf,'Tag','StxtParamInfo'),'String','LPIX vide')
case 'ButLP+'
	ud = get(gcbf,'UserData');
	val = [1,1];
	ud.Param = IsaacLPIX_add(ud.Param,val,IsaacImage_get(IsaacImageCible,'IMG'));
	ud.PixL = IsaacLPIX_get(ud.Param,'PixNb');
	ud.PixE = val;
	set(gcbf,'UserData',ud);
	set(findobj(gcbf,'Tag','StxtLPeffval'),'String',num2str(ud.PixL))
	set(findobj(gcbf,'Tag','ListLP'),'Enable','on')
	MajListePix
	set(findobj(gcbf,'Tag','EtxtCoord'),'Enable','on')
	MajCoord
	set(findobj(gcbf,'Tag','ButLPadjust'),'Enable','on')
	set(findobj(gcbf,'Tag','ButLP-'),'Enable','on')
	set(findobj(gcbf,'Tag','ButLPclear'),'Enable','on')
case 'ButLP-'
	ud = get(gcbf,'UserData');
	ud.Param = IsaacLPIX_remove(ud.Param,ud.PixL);
	pixnb = IsaacLPIX_get(ud.Param,'PixNb');
	if ~pixnb
		set(gcbo,'Enable','off')
		set(findobj(gcbf,'Tag','StxtLPeffval'),'String','0')
		set(findobj(gcbf,'Tag','ListLP'),'Enable','off','String','')
		set(findobj(gcbf,'Tag','ButLPadjust'),'Enable','off')
		set(findobj(gcbf,'Tag','ButLPclear'),'Enable','off')
		set(findobj(gcbf,'Tag','EtxtCoord'),'Enable','inactive','String','')
		set(findobj(gcbf,'Tag','StxtParamInfo'),'String','LPIX vide')
	else
		if ud.PixL > pixnb
			ud.PixL = pixnb;
		end
		pix = IsaacLPIX_get(ud.Param,'Pix');
		ud.PixE = pix(ud.PixL,1:2);
		MajCoord
		set(findobj(gcbf,'Tag','StxtLPeffval'),'String',num2str(pixnb))
		MajListePix
	end	
	set(gcbf,'UserData',ud);
	
% Gnral ------------------------------------------------------------------------------------------

case 'CloseBox'
	ud = get(gcbf,'UserData');
	if ~ISAACINFO.IsEnd
		IsaacEventUpdListe(gcbf,[])
	end
	rmpath(ud.ToolDir)
	closereq
case 'RadButParamCible'
	v = get(gcbo,'Value');
	if v == 1 % tait 0 vient d'tre mis  1
		ud = get(gcbf,'UserData');
		ud.PTarget = 1;
		set(gcbf,'UserData',ud);
		set(findobj(gcbf,'Tag','RadButParamMem'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamFich'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMATLAB'),'Value',0)
		set(findobj(gcbf,'Tag','EtxtVarname'),'Visible','off')
		set(findobj(gcbf,'Tag','ButParamPull'),'Visible','off')
		set(findobj(gcbf,'Tag','ButParamPush'),'Visible','off')
		cible = IsaacImageCible;
		if isempty(cible)
			LpixEdit_upd(gcbf,1,cible,NaN)
		else
			LpixEdit_upd(gcbf,2,cible,NaN)
		end
		% auteur = NaN car LpixEdit_upd n'accepte pas les vnements causs par soi-mme
	else % tait 1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'RadButParamMem'
	v = get(gcbo,'Value');
	if v == 1 % tait 0 vient d'tre mis  1
		ud = get(gcbf,'UserData');
		ud.PTarget = 2;
		set(gcbf,'UserData',ud);
		set(findobj(gcbf,'Tag','RadButParamCible'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamFich'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMATLAB'),'Value',0)
		set(findobj(gcbf,'Tag','ButParamPull'),'String','Lire','Visible','on')
		set(findobj(gcbf,'Tag','ButParamPush'),'String','Ecrire','Visible','on')
		set(findobj(gcbf,'Tag','EtxtVarname'),'Visible','off')
		set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
		set(findobj(gcbf,'Tag','EtxtCoord'),'Enable','inactive')
		set(findobj(gcbf,'Tag','ButLPselect'),'Enable','off')
		set(findobj(gcbf,'Tag','ButLPadjust'),'Enable','off')
		set(findobj(gcbf,'Tag','ButLP+'),'Enable','off')
	else % tait 1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'RadButParamFich'
	v = get(gcbo,'Value');
	if v == 1 % tait 0 vient d'tre mis  1
		ud = get(gcbf,'UserData');
		ud.PTarget = 3;
		set(gcbf,'UserData',ud);
		set(findobj(gcbf,'Tag','RadButParamCible'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMem'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMATLAB'),'Value',0)
		set(findobj(gcbf,'Tag','ButParamPull'),'String','Ouvrir...','Visible','on')
		set(findobj(gcbf,'Tag','ButParamPush'),'String','Sauver sous...','Visible','on')
		set(findobj(gcbf,'Tag','EtxtVarname'),'Visible','off')
		set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
		set(findobj(gcbf,'Tag','EtxtCoord'),'Enable','inactive')
		set(findobj(gcbf,'Tag','ButLPselect'),'Enable','off')
		set(findobj(gcbf,'Tag','ButLPadjust'),'Enable','off')
		set(findobj(gcbf,'Tag','ButLP+'),'Enable','off')
	else % tait 1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'RadButParamMATLAB'
	v = get(gcbo,'Value');
	if v == 1 % tait 0 vient d'tre mis  1
		ud = get(gcbf,'UserData');
		ud.PTarget = 4;
		set(gcbf,'UserData',ud)
		set(findobj(gcbf,'Tag','RadButParamCible'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMem'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamFich'),'Value',0)
		set(findobj(gcbf,'Tag','ButParamPull'),'String','Importer','Visible','on')
		set(findobj(gcbf,'Tag','ButParamPush'),'String','Exporter','Visible','on')
		set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
		set(findobj(gcbf,'Tag','EtxtCoord'),'Enable','inactive')
		set(findobj(gcbf,'Tag','ButLPselect'),'Enable','off')
		set(findobj(gcbf,'Tag','ButLPadjust'),'Enable','off')
		set(findobj(gcbf,'Tag','ButLP+'),'Enable','off')
		set(findobj(gcbf,'Tag','EtxtVarname'),'Visible','on')
	else % tait  1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end
case 'EtxtVarname'
	ud = get(gcbf,'UserData');
	ud.PVarName = get(gcbo,'String');
	set(gcbf,'UserData',ud);
	set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
case 'ButParamPull'
	ud = get(gcbf,'UserData');
	switch ud.PTarget
		case 2 % Mmoire
			P = IsaacParamPull('LPIX');
			if isempty(P)
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
					'String','mmoire vide')
			else
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
					'String','mmoire lue')
				ud.Param = P;
				MajWhenPull
				set(gcbf,'UserData',ud);
			end	
		case 3 % Fichier
			[filename,dirname] = IsaacUIgetfile('Ouvrir une liste de pixels :');
			if filename == 0
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
				return
			end
			try
				ud.Param = IsaacLPIX(fullfile(dirname,filename));
				IsaacCD(dirname)
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
					'String',['fichier ',filename,' lu'])
				MajWhenPull
				set(gcbf,'UserData',ud);
			catch exception
				IsaacMessageErreur(IsaacError(exception))
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
					'String','chec lecture fichier')
				return
			end
		case 4 % MATLAB base workspace
			try
				ud.Param = IsaacParamImport('LPIX',ud.PVarName);
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
					'String',['variable ',ud.PVarName,' importe'])
				MajWhenPull
				set(gcbf,'UserData',ud);
			catch exception
				IsaacMessageErreur(IsaacError(exception))
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
					'String','chec import MATLAB')
				return
			end	
	end
case 'ButParamPush'
	ud = get(gcbf,'UserData');
	switch ud.PTarget
		case 2 % Mmoire
			IsaacParamPush(ud.Param)
			set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
				'String','LPIX mmorise')
		case 3 % Fichier
			[filename,dirname] = IsaacUIputfile('Sauver sous :',IsaacFileName('LPIX.mat'));
			if filename == 0
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
				return
			end
			try
				IsaacLPIX_saveas(ud.Param,fullfile(dirname,filename));
				IsaacCD(dirname)
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
				'String',['fichier ',filename,' sauv'])
			catch exception
				IsaacMessageErreur(IsaacError(exception))
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
					'String','chec criture fichier')
				return
			end
		case 4 % MATLAB base workspace
			try
				IsaacParamExport(ud.Param,ud.PVarName)
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
					'String',['variable ',ud.PVarName,' exporte'])
			catch exception
				IsaacMessageErreur(IsaacError(exception))
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
					'String','chec export MATLAB')
				return
			end	
	end		
end

% --- Nested fonction ------------------------------------------------------------------------------

function MajWhenPull
	
pixnb = IsaacLPIX_get(ud.Param,'PixNb');
if ~pixnb
	set(findobj(gcbf,'Tag','ListLP'),'Enable','off','String','')
	set(findobj(gcbf,'Tag','StxtLPeffval'),'String','0')
	set(findobj(gcbf,'Tag','ButLP-'),'Enable','off')
	set(findobj(gcbf,'Tag','ButLPclear'),'Enable','off')
	set(findobj(gcbf,'Tag','EtxtCoord'),'String','')
	set(findobj(gcbf,'Tag','StxtParamInfo'),'String','LPIX vide')
else
	pix = IsaacLPIX_get(ud.Param,'Pix');
	ud.PixL = pixnb;
	ud.PixE = pix(ud.PixL,1:2);
	set(findobj(gcbf,'Tag','StxtLPeffval'),'String',num2str(pixnb))
	set(findobj(gcbf,'Tag','ListLP'),'Enable','on')
	MajListePix
	MajCoord
	set(findobj(gcbf,'Tag','ButLP-'),'Enable','on')
	set(findobj(gcbf,'Tag','ButLPclear'),'Enable','on')
end

end % fin nested fonction

% --- Nested fonction ------------------------------------------------------------------------------

function MajCoord

s = [num2str(ud.PixE(1),ud.PixSpaFormat),' , ',num2str(ud.PixE(2),ud.PixSpaFormat)];
set(findobj(gcbf,'Tag','EtxtCoord'),'String',s)

end % fin nested fonction

% --- Nested fonction ------------------------------------------------------------------------------

function MajListePix

pix = IsaacLPIX_get(ud.Param,'Pix');
switch ud.BitFormat
	case 1
      if verLessThan('matlab', '9.0') 
         % code pour MATLAB 2015b et antrieur
         val = double(im2bw(pix(:,3:end),0.5));                                                 %#ok
      else
         % code pour MATLAB 2016a (9.0) et postrieur
         val = double(imbinarize(pix(:,3:end),0.5));
      end
	case 8
		val = round(pix(:,3:end)*255);
	case 16
		val = round(pix(:,3:end)*65535);
	otherwise
		val = pix(:,3:end);
end	
nb = size(pix,1);
s = cell(nb,1);
for ii = 1:nb
	s{ii} = [' ',num2str(pix(ii,1:2),ud.PixSpaFormat),'   ',num2str(val(ii,1:end),ud.PixValFormat)];
end	
set(findobj(gcbf,'Tag','ListLP'),'String',s,'Value',ud.PixL)
imaref = IsaacLPIX_get(ud.Param,'ImaRef');
s = ['LPIX (',num2str(imaref.dimx),' x ',num2str(imaref.dimy),' x ',num2str(imaref.dimz),')'];
set(findobj(gcbf,'Tag','StxtParamInfo'),'String',s)

end % fin nested fonction

%---------------------------------------------------------------------------------------------------

end % fin LpixEdit_cb en raison des nested fonctions
