function IsaacAbout()
% Ecran A propos (dialogue modal)
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

global ISAACCONST
global ISAACPREF

% cration cran about
% figure(position selon ISAACCONST.DefPos)
h0 = figure( ...
	'CloseRequestFcn','IsaacAbout_cb ButClose', ...
	'Name','A propos d''Isaac ...', ... 
	'Position',IsaacFenPos(ISAACCONST.DefPos(1),ISAACCONST.DefPos(2),410,200,0), ...
	'WindowStyle','modal');

IsaacDefaultProperties(h0)

% Texte Isaac et version	
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'FontSize',ISAACPREF.FontSize + 2, ...
	'FontWeight','Bold', ...
	'HorizontalAlignment','left', ...
	'Position',[15 175 365 20], ...
	'String',[ISAACCONST.Info.IsaacName,' ',ISAACCONST.Info.IsaacVersion], ...
	'Style','text');
% Texte "que fait Isaac"	
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'FontAngle','Italic', ...
	'FontWeight','Bold', ...
	'FontSize',ISAACPREF.FontSize + 2, ...
	'HorizontalAlignment','left', ...
	'Position',[15 155 365 20], ...
	'String',ISAACCONST.Info.IsaacTitle, ...
	'Style','text');
% Texte "copyright"	
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'HorizontalAlignment','left', ...
	'Position',[15 135 365 20], ...
	'String',ISAACCONST.Info.Copyright, ...
	'Style','text');
% Texte titre & nom auteur	
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'HorizontalAlignment','left', ...
	'Position',[120 105 100 15], ...
	'String',[ISAACCONST.Info.AuthorTitle,' ',ISAACCONST.Info.AuthorName], ...
	'Style','text');
% Texte adresse auteur	
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'HorizontalAlignment','left', ...
	'Position',[120 45 300 60], ...
	'String',ISAACCONST.Info.AuthorAdress, ...
	'Style','text');
% Axes et Image Auteur	
try
	img = imread(fullfile(ISAACCONST.ResDir,ISAACCONST.Info.AuthorPhoto));
	dimy = size(img,1); 
	dimx = size(img,2);
	% [dimy dimx] =size(img) retourne size(img,2)*size(img,3) dans dimx car 3 plans rgb !!!
	h1 = axes('Parent',h0, ...
		'Box','on', ...
		'DataAspectRatio',[1 1 1], ...
		'DataAspectRatioMode','manual', ...
		'PlotBoxAspectRatio',[1 1 1], ...
		'PlotBoxAspectRatioMode','manual', ...
		'Position',[5 5 dimx+2 dimy+1], ...	
		'Visible','on', ...
		'XLim', [0 dimx+1], ...
		'YLim', [0 dimy+1],...
		'XTick',[], ...
		'YTick',[], ...
		'YDir', 'reverse');
	% Axes = 1 de + de chaque cot de l'image pour le cadre (box)
	% Le cadre du bas est  4 pixels du bord et non 5 : bug ?
	% => proprit 'Position'  dimy+1 au lieu de dimy+2 en thorie
	image('Parent',h1, ...
		'Clipping','off', ...
		'CData',img);
catch exception
	IsaacMessageErreur(IsaacError(exception))
	closereq
	return
end
% Texte email auteur	
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'HorizontalAlignment','left', ...
	'Position',[120 40 250 15], ...
	'String',['contact : ',ISAACCONST.Info.AuthorEmail], ...
	'Style','text');

drawnow; % Flush les evenements graphiques en attente
IsaacSound('About')
	
% Bouton Close	
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACPREF.IsaacColor3, ...
	'Callback','IsaacAbout_cb ButClose', ...
	'Enable','on', ...
	'Position',[345 5 60 20], ...
	'String','Fermer');

%---------------------------------------------------------------------------------------------------

% Initialisation
uiwait(h0) % bloque l'execution de l'appelant jusqu' resume ou close figure

