function IsaacMenuBar_addtools(rep,menuhnd,startpos,separator)
% Ajout des outils du rpertoire rep comme items dans le menu menuhnd  partir de startpos avec un
% sparateur si separator = true
% (partag par IsaacMenuBar et IsaacMenuBar_cb)
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

% uimenu/UserData = rpertoire de chaque outil

%---------------------------------------------------------------------------------------------------


try
	d = dir(rep); % d = 0x1 struct array si rep non existant => menu vide
	l = length(d);
	n = 0;
	for i = 1:l
		if d(i).isdir == 1
			% recherche du .m ou .p de mme nom
			fullfilename = fullfile(rep,d(i).name,d(i).name);
			if exist([fullfilename,'.m'],'file') || exist([fullfilename,'.p'],'file')
				n = n+1;
				h2 = uimenu('Parent',menuhnd, ...
					'Callback','IsaacMenuBar_cb MItemTool', ...
					'Label',d(i).name, ...
					'Position',startpos+n-1, ...
					'Tag',d(i).name, ...
					'UserData',fullfile(rep,d(i).name));
				if ((n == 1) && separator)
					set(h2,'Separator','on');
				end					
			end
		end
	end
catch exception
	IsaacMessageErreur(rep,IsaacError(exception))
end

		